/* Sir Drink a lot & Rinde, 25.09.03 */

/* Includes */
#include <adminlib>
#include <plugin>

/* Constants */
#define OLD_NAMES 0
#define MENU 0

#define ACCESS_LIST ACCESS_ALL
#define ACCESS_VOTE_RESTART 1
#define ACCESS_RESTART 2
#define ACCESS_CHANGE_TEAM 8192
#define ACCESS_RESTRICT 8192
#define ACCESS_RESTRICT_PRESERVE 8192

#define MAX_ITEMS   32

#define MENU_MAIN       0
#define MENU_PISTOLS    1
#define MENU_SHOTGUNS   2
#define MENU_SMGS       3
#define MENU_RIFLES     4
#define MENU_MG         5
#define MENU_SECAMMO    6
#define MENU_PRIMAMMO   7
#define MENU_EQUIPMENT  8
#define MENU_INVALID    9
#define MENU_CANCEL     10
#define MENU_RESTRICT   11
#define MENU_NONE       12

#define ITEM_ENABLED 0
#define ITEM_RESTRICTED 1

/* Global Variables */
new g_Version[] = "1.0 RC1";
#if OLD_NAMES == 0
new g_ItemName[MAX_ITEMS][]= {
    "9x19mm Sidearm",
    "K&M .45 Tactical",
    "228 Compact",
    "Night Hawk .50C",
    ".40 Dual Elites",
    "ES Five-Seven",
    "Leone 12 Gauge Super",
    "Leone YG1265 Auto Shotgun",
    "Ingram MAC-10",
    "K&M Sub-Machine Gun",
    "K&M UMP45",
    "ES C90",
    "Schmidt Machine Pistol",
    "IDF Defender",
    "CV-47",
    "Schmidt Scout",
    "Krieg 552 Commando",
    "Magnum Sniper Rifle",
    "D3/AU-1 Semi-Auto Sniper Rifle",
    "Clarion 5.56",
    "Bullpup",
    "Maverick M4A1 Carabine",
    "Krieg 550 Commando",
    "ES M249 Para",
    "Kevlar Vest",
    "Kevlar Vest & Helmet",
    "Flashbang",
    "HE Grenade",
    "Smoke Grenade",
    "Defuse Kit",
    "NightVision Goggles",
    "Tactical Shield"
};
#else
new g_ItemName[MAX_ITEMS][]= {
    "Glock18 Select Fire",
    "H&K USP .45 Tactical",
    "SIG P228",
    "Desert Eagle .50AE",
    "Dual Beretta 96G Elite",
    "FN Five-Seven",
    "Benelli M3 Super90",
    "Benelli XM1014",
    "Ingram MAC-10",
    "H&K MP5-Navy",
    "H&K UMP45",
    "FN P90",
    "Steyr Tactical Machine Pistol",
    "Galil",
    "AK-47",
    "Steyr Scout",
    "Sig SG-552 Commando",
    "AI Arctic Warfare/Magnum",
    "H&K G3/SG-1 Sniper Rifle",
    "Famas",
    "Steyr Aug",
    "Colt M4A1 Carabine",
    "Sig SG-550 Sniper",
    "FN M249 Para",
    "Kevlar Vest",
    "Kevlar Vest & Helmet",
    "Flashbang",
    "HE Grenade",
    "Smoke Grenade",
    "Defuse Kit",
    "NightVision Goggles",
    "Tactical Shield"
};
#endif
new g_ClientCommands1[MAX_ITEMS][]= {
    "glock",
    "usp",
    "p228",
    "deagle",
    "elites",
    "fn57",
    "m3",
    "xm1014",
    "mac10",
    "mp5",
    "ump45",
    "p90",
    "tmp",
    "galil",
    "ak47",
    "scout",
    "sg552",
    "awp",
    "g3sg1",
    "famas",
    "aug",
    "m4a1",
    "sg550",
    "m249",
    "vest",
    "vesthelm",
    "flash",
    "hegren",
    "sgren",
    "defuser",
    "nvgs",
    "shield"
};
new g_ClientCommands2[MAX_ITEMS][]= {
    "9x19mm",
    "km45",
    "229compact",
    "nighthawk",
    "elites",
    "fiveseven",
    "12gauge",
    "autoshotgun",
    "mac10",
    "smg",
    "ump45",
    "c90",
    "mp",
    "defender",
    "cv47",
    "scout",
    "krieg552",
    "magnum",
    "d3au1",
    "clarion",
    "bullup",
    "m4a1",
    "krieg550",
    "m249",
    "vest",
    "vesthelm",
    "flash",
    "hegren",
    "sgren",
    "defuser",
    "nvgs",
    "shield"
};
new g_ItemRestricted[2][MAX_ITEMS + 1] = {{ITEM_ENABLED},{ITEM_ENABLED}}; // + 1 so we have a fake item that is never retricted
new g_ItemIndexByKeys[2][26] = {
    {0,1,2,3,4,6,7,8,9,10,11,13,14,15,16,17,18,23,24,25,26,27,28,30,MAX_ITEMS,MAX_ITEMS}, // let non-existent key combinations point to the fake item
    {0,1,2,3,5,6,7,12,9,10,11,19,15,21,20,22,17,23,24,25,26,27,28,29,30,31}
};
new g_MenuEntriesIndexBegin[9] = {0,5,7,11,17,18,18,18,26};
new g_ItemIndexBegin[9] = {0,6,8,13,23,24,24,24,32};
new g_UserMenuSelected[MAX_PLAYERS] = {MENU_NONE};
new g_RestrictedItemsNum = 0;
new g_StatusText[2][] = {"enabled","restricted"};
#if MENU
new g_SubMenuTitles[8][] = {"Handgun^n(Secondary weapon)","Shotgun^n(Primary weapon)","Sub-Machine Gun^n(Primary weapon)","Rifle^n(Primary weapon)","Machine Gun^n(Primary weapon)","","","Equipment"};
new g_UserMenuOrder[MAX_PLAYERS];
new g_UserPRestriction[MAX_PLAYERS];
#endif

/* Function Declarations */
forward HandleRestartVote(WinningOption,HLUser,VoteCount,UserCount);
forward AdminChangeTeam(HLCommand,HLData,HLUserName,UserIndex);
forward AdminVoteRestart(HLCommand,HLData,HLUserName,UserIndex);
forward AdminRestartRound(HLCommand,HLData,HLUserName,UserIndex);
forward HandleAll(HLCommand,HLData,HLUserName,UserIndex);
forward HandleMenu(HLCommand,HLData,HLUserName,UserIndex);
forward HandleEquipment(HLCommand,HLData,HLUserName,UserIndex);
forward HandleItem(HLCommand,HLData,HLUserName,UserIndex);
#if MENU
forward RestrictMenu(HLCommand,HLData,HLUserName,UserIndex);
#endif
forward WeaponsCheck(HLCommand,HLData,HLUserName,UserIndex);
forward ListItems(HLCommand,HLData,HLUserName,UserIndex);
forward SetMenu(HLCommand,HLData,HLUserName,UserIndex);
forward SetSelectData(HLCommand,HLData,HLUserName,UserIndex);
forward ClearMenu(HLCommand,HLData,HLUserName,UserIndex);
forward HandleBuy(HLCommand,HLData,HLUserName,UserIndex);
forward ChangeStatusAll(Status,Preserve = 0);
forward ChangeStatusMenu(Menu,Status,Preserve = 0);
forward ChangeStatusItem(Item,Status,Preserve = 0);
forward get_ItemIndex(sItem[]);
#if MENU
forward DrawSubMenu(UserIndex,Menu);
#endif

/* Event Handlers */
public plugin_init() {
    if(plugin_check("Admin Counterstrike Plugin","Commands specific to the Counterstrike mod.",g_Version)) return PLUGIN_CONTINUE;
    plugin_registercmd("admin_ct","AdminChangeTeam",ACCESS_CHANGE_TEAM,"admin_ct <target>: Changes target to the counter-terrorist team.");
    plugin_registercmd("admin_t","AdminChangeTeam",ACCESS_CHANGE_TEAM,"admin_t <target>: Changes target to the terrorist team.");
    plugin_registercmd("admin_vote_restart","AdminVoteRestart",ACCESS_VOTE_RESTART,"admin_vote_restart: Starts a vote to restart the round.");
    plugin_registercmd("admin_restartround","AdminRestartRound",ACCESS_RESTART,"admin_restartround <seconds>: Restarts the round.");
    plugin_registercmd("admin_restart","AdminRestartRound",ACCESS_RESTART,"admin_restartround <seconds>: Restarts the round.");
    plugin_registercmd("admin_enableallweapons","HandleAll",ACCESS_RESTRICT,"admin_enableallweapons [<^"p^">]: Allows anyone to buy anything.");
    plugin_registercmd("admin_restrictallweapons","HandleAll",ACCESS_RESTRICT,"admin_restrictallweapons [<^"p^">]: Forbids anyone from buying anything.");
    plugin_registercmd("admin_enablemenu","HandleMenu",ACCESS_RESTRICT,"admin_enablemenu <menu> [<^"p^">]: Allows anyone to buy anything on the specified menu.");
    plugin_registercmd("admin_restrictmenu","HandleMenu",ACCESS_RESTRICT,"admin_restrictmenu <menu> [<^"p^">]: Forbids anyone from buying anything on the specified menu.");
    plugin_registercmd("admin_enableequipment","HandleEquipment",ACCESS_RESTRICT,"admin_enableequipment [<^"p^">]: Allows anyone to buy any equipment.");
    plugin_registercmd("admin_restrictequipment","HandleEquipment",ACCESS_RESTRICT,"admin_restrictequipment [<^"p^">]: Forbids anyone from buying any equipment.");
    plugin_registercmd("admin_enableweapon","HandleItem",ACCESS_RESTRICT,"admin_enableweapon <item> [<^"p^">]: Allows anyone to buy the specified item.");
    plugin_registercmd("admin_restrictweapon","HandleItem",ACCESS_RESTRICT,"admin_restrictweapon <item> [<^"p^">]: Forbids anyone from buying the specified item.");
#if MENU
    plugin_registercmd("admin_restrictionmenu","RestrictMenu",ACCESS_RESTRICT,"admin_restrictionmenu [<^"p^">]: Displays menu for changing weaponrestrictions.");
#endif
    plugin_registercmd("admin_weaponscheck","WeaponsCheck",ACCESS_RESTRICT,"admin_weaponscheck <^"on^" | ^"off^">: Toggles whether or not weapon restrictions are used.");
    plugin_registercmd("admin_listitems","ListItems",ACCESS_LIST,"admin_listitems [<#>]: Displays name and status of items, beginning with #");
    plugin_registercmd("buy","SetMenu",ACCESS_ALL);
    plugin_registercmd("buyequip","SetMenu",ACCESS_ALL);
    plugin_registercmd("menuselect","SetSelectData",ACCESS_ALL);
    plugin_registercmd("radio1","ClearMenu",ACCESS_ALL);
    plugin_registercmd("radio2","ClearMenu",ACCESS_ALL);
    plugin_registercmd("radio3","ClearMenu",ACCESS_ALL);
    plugin_registercmd("chooseteam","ClearMenu",ACCESS_ALL);
    plugin_registercmd("showbriefing","ClearMenu",ACCESS_ALL);
    new Key[MAX_ITEMS + 1]; // Terminating 0
    new i;
    get_vaultdata("RESTRICTIONS",Key,MAX_ITEMS + 1);
    if(!Key[0]) set_vaultdata("RESTRICTIONS","0000000000000000000000000000000");
    for(i=0;i<MAX_ITEMS;i++) {
        plugin_registercmd(g_ClientCommands1[i],"HandleBuy",ACCESS_ALL);
        plugin_registercmd(g_ClientCommands2[i],"HandleBuy",ACCESS_ALL);
        if(Key[i] - '0' == ITEM_RESTRICTED) {
            g_ItemRestricted[0][i] = ITEM_RESTRICTED;
            g_ItemRestricted[1][i] = ITEM_RESTRICTED;
            g_RestrictedItemsNum++;
        }
    }
    return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP,UserIndex) {
    if(0 < UserIndex <= MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
    if(0 < UserIndex <= MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}

public HandleRestartVote(WinningOption,HLUser,VoteCount,UserCount) {
    if(WinningOption == 1 ) {
        new ratio = getvar("map_ratio");
        if(VoteCount < (ratio/100)*UserCount) {
            say("Not enough votes for map restart");
        } else {
            new Timelimit[MAX_NUMBER_LENGTH];
            numtostr((getvar("mp_timelimit") * 60 - timeleft() + 10) / 60,Timelimit);
            setstrvar("mp_timelimit",Timelimit);
            setstrvar("sv_restartround","10");
            say("Map restart vote succeeded.");
        }
    } else {
        say("Map restart vote failed.");
    }
}

/* Command Handlers */
public AdminChangeTeam(HLCommand,HLData,HLUserName,UserIndex) {
    new Command[MAX_COMMAND_LENGTH];
    new Data[MAX_DATA_LENGTH];
    new TargetName[MAX_NAME_LENGTH];
    new Text[MAX_TEXT_LENGTH];
    new User[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_NAME_LENGTH);
    convert_string(HLData,Data,MAX_NAME_LENGTH);
    convert_string(HLUserName,User,MAX_NAME_LENGTH);
    if(!check_user(Data)) {
        selfmessage("Unrecognized player: ");
        selfmessage(Data);
    } else {
        get_username(Data,TargetName,MAX_NAME_LENGTH);
        if(check_immunity(TargetName) != 0) {
            snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't move %s onto another team, you silly bear.", TargetName);
            messageex(User,Text,print_chat);
        } else {
            say_command(User,Command,TargetName);
            if(!strcmp(Command,"admin_ct")) {
                execclient(TargetName, "chooseteam;menuselect 2");
            } else {
                execclient(TargetName, "chooseteam;menuselect 1");
            }
        }
    }
    return PLUGIN_HANDLED;
}

public AdminVoteRestart(HLCommand,HLData,HLUserName,UserIndex) {
    new ratio = getvar("map_ratio");
    if(!ratio) {
        say("Restart vote is not enabled");
    } else if(!vote_allowed()) {
        selfmessage( "Vote not allowed at this time.");
    } else {
        vote("Restart map & begin play?","Yes","No","HandleRestartVote","");
    }
    return PLUGIN_HANDLED;
}

public AdminRestartRound(HLCommand,HLData,HLUserName,UserIndex) {
    new Command[MAX_COMMAND_LENGTH];
    new Data[MAX_DATA_LENGTH];
    new User[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    convert_string(HLUserName,User,MAX_NAME_LENGTH);
    execute_command(User,Command,"sv_restartround",Data);
    return PLUGIN_HANDLED;
}

public HandleAll(HLCommand,HLData,HLUserName,UserIndex) {
    if(!getvar("admin_cs_restrict")) {
        selfmessage("Restriction is ignored, because 'admin_cs_restrict' is disabled.");
        selfmessage("Use command ^"admin_weaponcheck on^" to enable item-restrictions.");
        return PLUGIN_HANDLED;
    }
    new Command[MAX_COMMAND_LENGTH];
    new Data[MAX_DATA_LENGTH];
    new UserName[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
    strstripquotes(Data);
    say_command(UserName,Command,Data);
    ChangeStatusAll(tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED);
    if(!strcasecmp(Data,"p") && check_auth(ACCESS_RESTRICT_PRESERVE)) {
        ChangeStatusAll(tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,1);
    }
    ChangeStatusAll(tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,0);
    return PLUGIN_HANDLED;
}

public HandleMenu(HLCommand,HLData,HLUserName,UserIndex) {
    if(!getvar("admin_cs_restrict")) {
        selfmessage("Restriction is ignored, because 'admin_cs_restrict' is disabled.");
        selfmessage("Use command ^"admin_weaponcheck on^" to enable item-restrictions.");
        return PLUGIN_HANDLED;
    }
    new Data[MAX_DATA_LENGTH];
    new sMenu[MAX_DATA_LENGTH];
    new Menu;
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    strstripquotes(Data);
    strsep(Data," ",sMenu,MAX_DATA_LENGTH,Data,MAX_DATA_LENGTH);
    Menu = strtonum(sMenu);
    if(!(0 < Menu < MENU_PRIMAMMO || Menu == MENU_EQUIPMENT)) {
        selfmessage("Restriction is ignored, because you did not enter a valid menu number.");
        return PLUGIN_HANDLED;
    }
    new Command[MAX_COMMAND_LENGTH];
    new UserName[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
    convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
    say_command(UserName,Command,sMenu);
    if(!strcasecmp(Data,"p") && check_auth(ACCESS_RESTRICT_PRESERVE)) {
        ChangeStatusMenu(Menu,tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,1);
    }
    ChangeStatusMenu(Menu,tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,0);
    return PLUGIN_HANDLED;
}

public HandleEquipment(HLCommand,HLData,HLUserName,UserIndex) {
    if(!getvar("admin_cs_restrict")) {
        selfmessage("Restriction is ignored, because 'admin_cs_restrict' is disabled.");
        selfmessage("Use command ^"admin_weaponcheck on^" to enable item-restrictions.");
        return PLUGIN_HANDLED;
    }
    new Command[MAX_COMMAND_LENGTH];
    new Data[MAX_DATA_LENGTH];
    new UserName[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
    strstripquotes(Data);
    say_command(UserName,Command,Data);
    if(!strcasecmp(Data,"p") && check_auth(ACCESS_RESTRICT_PRESERVE)) {
        ChangeStatusMenu(MENU_EQUIPMENT,tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,1);
    }
    ChangeStatusMenu(MENU_EQUIPMENT,tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,0);
    return PLUGIN_HANDLED;
}

public HandleItem(HLCommand,HLData,HLUserName,UserIndex) {
    if(!getvar("admin_cs_restrict")) {
        selfmessage("Restriction is ignored, because 'admin_cs_restrict' is disabled.");
        selfmessage("Use command ^"admin_weaponcheck on^" to enable item-restrictions.");
        return PLUGIN_HANDLED;
    }
    new Data[MAX_DATA_LENGTH];
    new sItem[MAX_DATA_LENGTH];
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    strstripquotes(Data);
    strsep(Data," ",sItem,MAX_DATA_LENGTH,Data,MAX_DATA_LENGTH);
    new Item = get_ItemIndex(sItem);
    if(!(-1 < Item < MAX_ITEMS)) {
        selfmessage("Restriction is ignored, because you did not enter a valid item.");
        return PLUGIN_HANDLED;
    }
    new Command[MAX_COMMAND_LENGTH];
    new UserName[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
    convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
#if OLD_NAMES
    say_command(UserName,Command,g_ClientCommands1[Item]);
#else
    say_command(UserName,Command,g_ClientCommands2[Item]);
#endif
    if(!strcasecmp(Data,"p") && check_auth(ACCESS_RESTRICT_PRESERVE)) {
        ChangeStatusItem(Item,tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,1);
    }
    ChangeStatusItem(Item,tolower(Command[6]) == 'r' ? ITEM_RESTRICTED : ITEM_ENABLED,0);
    return PLUGIN_HANDLED;
}

#if MENU
public RestrictMenu(HLCommand,HLData,HLUserName,UserIndex) {
    if(!UserIndex) {
        selfmessage("This command cannot be used from console.");
        return PLUGIN_HANDLED;
    }
    if(!getvar("admin_cs_restrict")) {
        selfmessage("Can't use restrictions, because 'admin_cs_restrict' is disabled.");
        selfmessage("Use command ^"admin_weaponcheck on^" to enable item-restrictions.");
        return PLUGIN_HANDLED;
    }
    new Data[MAX_DATA_LENGTH];
    new iTeam;
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    strstripquotes(Data);
    g_UserMenuSelected[UserIndex] = MENU_RESTRICT;
    g_UserPRestriction[UserIndex] = strcasecmp(Data,"p") ? 0 : 1;
    convert_string(HLUserName,Data,MAX_NAME_LENGTH);
    get_userTeam(Data,iTeam);
    g_UserMenuOrder[UserIndex] = clamp(iTeam - 1,0,1);
    menu(Data,"\yRestrict Item\w^n^n1. Handgun^n2. Shotgun^n3. Sub-Machine Gun^n4. Rifle^n5. Machine Gun^n^n6. Primary weapon ammo^n7. Secondary weapon ammo^n^n8. Equipment^n^n0. Exit",671,0);
    return PLUGIN_HANDLED;
}
#endif

public WeaponsCheck(HLCommand,HLData,HLUserName,UserIndex) {
    new Command[MAX_COMMAND_LENGTH];
    new Data[MAX_DATA_LENGTH];
    new UserName[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_NAME_LENGTH);
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
    if(check_param(Data)) {
        execute_command(UserName,Command,"admin_cs_restrict","1");
    } else {
        execute_command(UserName,Command,"admin_cs_restrict","0");
    }
    return PLUGIN_HANDLED;
}

public ListItems(HLCommand,HLData,HLUserName,UserIndex) {
    new Data[MAX_DATA_LENGTH];
    new Start;
    new i;
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    Start = strtonum(Data) - 1;
    if(!(0 <= Start < MAX_ITEMS)) Start = 0;
    for(i=Start;i<Start+10 && i<MAX_ITEMS;i++) {
        snprintf(Data,MAX_DATA_LENGTH,"%i: %s -- %s is %s%s.",i + 1,g_ClientCommands1[i],g_ClientCommands2[i],g_StatusText[g_ItemRestricted[0][i]],g_ItemRestricted[1][i] ? " (permanently restricted)" : "");
        selfmessage(Data);
    }
    snprintf(Data,MAX_DATA_LENGTH,"----- Entries %i - %i Of %i  -----",Start + 1,i,MAX_ITEMS);
    selfmessage(Data);
    if(i < MAX_ITEMS) {
        snprintf(Data,MAX_DATA_LENGTH,"----- Use 'admin_listitems %i' For More -----",i + 1);
        selfmessage(Data);
    }

    return PLUGIN_HANDLED;
}

public SetMenu(HLCommand,HLData,HLUserName,UserIndex) {
    if(g_RestrictedItemsNum && getvar("admin_cs_restrict")) {
        static Command[MAX_COMMAND_LENGTH];
        convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
        if(!strcmp(Command,"buy")) {
            g_UserMenuSelected[UserIndex] = MENU_MAIN;
        } else {
            g_UserMenuSelected[UserIndex] = MENU_EQUIPMENT;
        }
    }
    return PLUGIN_CONTINUE;
}

public SetSelectData(HLCommand,HLData,HLUserName,UserIndex) {
    if(g_UserMenuSelected[UserIndex] != MENU_NONE && getvar("admin_cs_restrict")) {
        static Data[MAX_NUMBER_LENGTH];
        static SelectedNumber;
        convert_string(HLData,Data,MAX_NUMBER_LENGTH);
        strstripquotes(Data);
        SelectedNumber = strtonum(Data);
        if(!(0 < SelectedNumber < 11)) return PLUGIN_CONTINUE;
        if(SelectedNumber == MENU_CANCEL) {
            g_UserMenuSelected[UserIndex] = MENU_NONE;
#if MENU
        } else if(g_UserMenuSelected[UserIndex] == MENU_RESTRICT) {
            DrawSubMenu(UserIndex,SelectedNumber);
        } else if(g_UserMenuSelected[UserIndex] < 0) {
            if(SelectedNumber == MENU_INVALID) {
                g_UserMenuOrder[UserIndex] = g_UserMenuOrder[UserIndex] ? 0 : 1;
                DrawSubMenu(UserIndex,-g_UserMenuSelected[UserIndex]);
            } else {
                new i = g_ItemIndexByKeys[g_UserMenuOrder[UserIndex]][g_MenuEntriesIndexBegin[-g_UserMenuSelected[UserIndex]-1]+SelectedNumber-1];
  #if OLD_NAMES
                snprintf(Data,MAX_NUMBER_LENGTH,"%s %s",g_ClientCommands1[i],g_UserPRestriction[UserIndex] ? "p" : "");
  #else
                snprintf(Data,MAX_NUMBER_LENGTH,"%s %s",g_ClientCommands2[i],g_UserPRestriction[UserIndex] ? "p" : "");
  #endif
                plugin_exec(g_ItemRestricted[g_UserPRestriction[UserIndex]][i] == ITEM_RESTRICTED ? "admin_enableweapon" : "admin_restrictweapon",Data);
                DrawSubMenu(UserIndex,-g_UserMenuSelected[UserIndex]);
            }
#endif
        } else if(g_RestrictedItemsNum) {
            static UserName[MAX_NAME_LENGTH];
            convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
            if(g_UserMenuSelected[UserIndex] == MENU_MAIN) {
                if(SelectedNumber == MENU_PRIMAMMO || SelectedNumber == MENU_SECAMMO || SelectedNumber == MENU_INVALID) {
                    execclient(UserName,"menuselect 10");
                } else {
                    g_UserMenuSelected[UserIndex] = SelectedNumber;
                }
            } else if(SelectedNumber <= g_MenuEntriesIndexBegin[g_UserMenuSelected[UserIndex]] - g_MenuEntriesIndexBegin[g_UserMenuSelected[UserIndex] - 1]) {
                new Team;
                get_userTeam(UserName,Team);
                execclient(UserName,"menuselect 10");
                if(g_ItemRestricted[0][g_ItemIndexByKeys[Team - 1][g_MenuEntriesIndexBegin[g_UserMenuSelected[UserIndex] - 1] + SelectedNumber - 1]] == ITEM_RESTRICTED) {
                    messageex(UserName,"Item currently not allowed",print_center);
                    return PLUGIN_HANDLED;
                }
            }
        }
    }
    return PLUGIN_CONTINUE;
}

public ClearMenu(HLCommand,HLData,HLUserName,UserIndex) {
    g_UserMenuSelected[UserIndex] = MENU_NONE;
    return PLUGIN_CONTINUE;
}

public HandleBuy(HLCommand,HLData,HLUserName,UserIndex) {
    if(g_RestrictedItemsNum && getvar("admin_cs_restrict")) {
        static Command[MAX_COMMAND_LENGTH];
        static i;
        convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
        for(i=0;i<MAX_ITEMS;i++){
            if(g_ItemRestricted[0][i] == ITEM_RESTRICTED && (!strcasecmp(Command,g_ClientCommands1[i]) || !strcasecmp(Command,g_ClientCommands2[i]))) {
                new UserName[MAX_NAME_LENGTH];
                convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
                messageex(UserName,"Item currently not allowed",print_center);
                return PLUGIN_HANDLED;
            }
        }
    }
    return PLUGIN_CONTINUE;
}

/* Helper Functions */
plugin_check(Title[],Description[],Version[]) {
    new CvarData[MAX_DATA_LENGTH];
    new error;
    plugin_registerinfo(Title,Description,Version);
    getstrvar("admin_vault_file",CvarData,MAX_DATA_LENGTH);
    if(!fileexists(CvarData)) {
        error = 1;
        plugin_message("[ERROR]: admin_vault_file is required to point to a valid file");
    }
#if MENU
    getstrvar("amv_enable_beta",CvarData,MAX_DATA_LENGTH);
    if(strstr(CvarData,"menu1") == -1) {
        error = 1;
        plugin_message("[ERROR]: ^"amv_enable_beta^" is required to contain menu1");
    }
#endif
    if(error)
        plugin_registerinfo(Title,"Disabed, see logfile for reason","not loaded");
    return error;
}


ChangeStatusAll(Status,Preserve = 0) {
    new i;
    for(i=0;i<MAX_ITEMS;i++) {
        ChangeStatusItem(i,Status,Preserve);
    }
}

ChangeStatusMenu(Menu,Status,Preserve = 0) {
    new i;
    for(i=g_ItemIndexBegin[Menu - 1];i<g_ItemIndexBegin[Menu];i++) {
        ChangeStatusItem(i,Status,Preserve);
    }
}

ChangeStatusItem(Item,Status,Preserve = 0) {
    new Text[MAX_TEXT_LENGTH];
    if(g_ItemRestricted[Preserve][Item] != Status) {
        g_ItemRestricted[Preserve][Item] = Status;
        snprintf(Text,MAX_TEXT_LENGTH,"Item ^"%s^" %s%s.",g_ItemName[Item],g_StatusText[Status],Preserve ? " permanently" :"");
        selfmessage(Text);
        if(Preserve) {
            new Key[MAX_ITEMS + 1]; // Terminating 0
            new i;
            for(i=0;i<MAX_ITEMS;i++) {
                Key[i] = g_ItemRestricted[1][i] + '0';
            }
            set_vaultdata("RESTRICTIONS",Key);
        } else {
            g_RestrictedItemsNum += (Status == ITEM_RESTRICTED) ? 1 : -1;
        }
    } else {
        snprintf(Text,MAX_TEXT_LENGTH,"Item ^"%s^" already is %s%s.",g_ItemName[Item],g_StatusText[Status],Preserve ? " permanently" :"");
        selfmessage(Text);
    }
}

get_ItemIndex(sItem[]) {
    new i;
    for(i=0;i<MAX_ITEMS;i++) {
        if(!strcasecmp(sItem,g_ClientCommands1[i]) || !strcasecmp(sItem,g_ClientCommands2[i])) break;
    }
    return i;
}

#if MENU
DrawSubMenu(UserIndex,Menu) {
    new Menutext[512];
    new Text[100];
    new UserName[MAX_NAME_LENGTH];
    new i,j,k;
    snprintf(Menutext,512,"\y Restrict %s^n",g_SubMenuTitles[Menu-1]);
    for(i=g_MenuEntriesIndexBegin[Menu-1];i<g_MenuEntriesIndexBegin[Menu];i++) {
        j++;
        k = g_ItemIndexByKeys[g_UserMenuOrder[UserIndex]][i];
        if(k == MAX_ITEMS) break;
        snprintf(Text,100,"^n\w%i. %s%s%s",j,g_ItemRestricted[0][k] == ITEM_RESTRICTED ? "\r" : "",g_ItemName[k],(g_UserPRestriction[UserIndex] && g_ItemRestricted[1][k] == ITEM_RESTRICTED) ? "\y\Rperm." : "");
        strcat(Menutext,Text,512);
    }
    if(g_UserMenuOrder[UserIndex] == 0) {
        strcat(Menutext,"^n^n\w9. \ySwitch to CT Layout^n^n\w0. Exit",512);
    } else {
        strcat(Menutext,"^n^n\w9. \ySwitch to Terrorist Layout^n^n\w0. Exit",512);
    }
    playerinfo(UserIndex,UserName,MAX_NAME_LENGTH);
    g_UserMenuSelected[UserIndex] = -Menu;
    menu(UserName,Menutext,(1<<j)+767,0);
}
#endif